\ Menu.f 2021 Jan 11  Menu objects

\ cr .( Menu.f : Loading Window Menus...)

\ ---------------------------------------------------------------
\ Menu and push button support
\ ---------------------------------------------------------------
decimal 12 cells constant SizeOfWNDCLASSEX_2

SizeOfWNDCLASSEX_2 Buffer: WNDCLASSEX_2

((
: s_DWORD ( a -- a' )   dup CONSTANT cell+ ;

WNDCLASSEX_2
   s_DWORD WNDCLASSEX_2.cbSize
   s_DWORD WNDCLASSEX_2.style
   s_DWORD WNDCLASSEX_2.lpfnWndProc
   s_DWORD WNDCLASSEX_2.cbClsExtra
   s_DWORD WNDCLASSEX_2.cbWndExtra
   s_DWORD WNDCLASSEX_2.hInstance
   s_DWORD WNDCLASSEX_2.hIcon
   s_DWORD WNDCLASSEX_2.hCursor
   s_DWORD WNDCLASSEX_2.hbrBackground
   s_DWORD WNDCLASSEX_2.lpszMenuName
   s_DWORD WNDCLASSEX_2.lpszClassName
   s_DWORD WNDCLASSEX_2.hIconSm
WNDCLASSEX_2 - SizeOfWNDCLASSEX_2 = not [if]  cr ." Ooops! WNDCLASSEX_2 is the wrong size!!!" abort  [then]

create MyClassName  ," MyClassName" 0 c,

: WNDCLASSEX_2init ( -- )
   WNDCLASSEX_2 SizeOfWNDCLASSEX_2 erase
   SizeOfWNDCLASSEX_2 WNDCLASSEX_2.cbSize !
   CS_VREDRAW CS_HREDRAW or CS_BYTEALIGNWINDOW or WNDCLASSEX_2.style !
   WNDPROC WNDCLASSEX_2.lpfnWndProc !
   0 WNDCLASSEX_2.cbClsExtra !
   0 WNDCLASSEX_2.cbWndExtra !
   hModule @ WNDCLASSEX_2.hInstance !
   hIconMain @ WNDCLASSEX_2.hIcon !
   hCurMain @ WNDCLASSEX_2.hCursor !
   0 WNDCLASSEX_2.hbrBackground !
   0 WNDCLASSEX_2.lpszMenuName !
   MyClassName WNDCLASSEX_2.lpszClassName !
   hIconMain @ WNDCLASSEX_2.hIconSm !
;

: RegisterWNDCLASS ( -- )   
   \ WNDCLASSEX_2init    \ initialise the Class structure that we are going to register
   GetHandle: TheMainWindow  call RegisterClass 0= if cr  RED. ." RegisterClassEx error! " RESTORE. .LAST-ERROR #101003 throw  then
;

: UnregisterWNDCLASS ( -- )   
   MyClassName GetHandle: TheMainWindow  call UnRegisterClass 0= if cr  RED. ." UnRegisterClass error! " RESTORE. .LAST-ERROR #1010043 throw  then
;
))

variable I'mDone  \ set to exit the application

LRButtonBar Demo-LR-Buttons
ENDBAR

VButtonBar Demo-V-buttons
     AddButton  " 300 Baud "          '9' pushkey ;
        ButtonInfo"  Set the Baudrate to 300"
     AddButton  " 4800 Baud "         '0' pushkey ;
        ButtonInfo"  Set the Baudrate to 4800"

     AddButton  " Port COM1 "         '1' pushkey ;
        ButtonInfo"  Connect to serial port 1 "
     AddButton  " Port COM2 "         '2' pushkey ;
        ButtonInfo"  Connect to serial port 2 "
     AddButton  " Port COM3 "         '3' pushkey ;
        ButtonInfo"  Connect to serial port 3 "
     AddButton  " Port COM4 "         '4' pushkey ;
        ButtonInfo"  Connect to serial port 4 "
     AddButton  " Port COM5 "         '5' pushkey ;
        ButtonInfo"  Connect to serial port 5 "
     AddButton  " Port COM6 "         '6' pushkey ;
        ButtonInfo"  Connect to serial port 6 "

     AddButton  " Port COM +"         '7' pushkey ;
        ButtonInfo"  Increment the serial COM port number "
     AddButton  " Port COM -"         '8' pushkey ;
        ButtonInfo"  Decrement the serial COM port number "

\        ButtonInfo"  Find a unit connected to a serial port... "
\      AddButton  " Test Serial Port "        'T' pushkey ;
\        ButtonInfo"  A simple terminal program "
\     AddButton  " Select File "              'F' pushkey ;
\        ButtonInfo"  Select the file to use for Download of Upload "

\     AddButton  "  "         'N' pushkey ;
\        ButtonInfo"   "

     AddButton  " Old Upload "               'P' pushkey ;
        ButtonInfo"  Upload a file from the unit using the 'old' format... "

     AddButton  " Old Download "             'O' pushkey ;
        ButtonInfo"  Download a file to the unit using the 'old' format... "

     AddButton  " Upload"	                  'U' pushkey ;
        ButtonInfo"  Upload a file from the unit "

     AddButton  " Download"                  'D' pushkey ;
        ButtonInfo"  Download a file to the unit "

\     AddButton  "  "         'N' pushkey ;
\        ButtonInfo"   "

     AddButton  " Start "                    'R' pushkey ;
        ButtonInfo"  Start the Transfer "

     AddButton  " Stop "                     'C' pushkey ;
        ButtonInfo"  Stop the Transfer "

     AddButton  " Help "      k_F1 pushkey ;
        ButtonInfo"  Display the Help Screen "

     AddButton  "  "         'M' pushkey ;
        ButtonInfo"   "

     AddButton  "  "         'T' pushkey ;
        ButtonInfo"   "

 \    AddButton  " Terminal "         'T' pushkey ;
 \       ButtonInfo" Test communications  "

     AddButton  "  "         'N' pushkey ;
        ButtonInfo"   "

\     AddButton  " TTY "                      'T' pushkey ;
\        ButtonInfo"   "

ENDBAR

100 SetButtonWidth: Demo-V-buttons      \ adjust the button width

ToolBar Demo-Tool-Bar "SinarF4.BMP"
        03 HSpace
\     1 PictureButton                    'O' +k_control pushkey  ; \ open
\        ButtonInfo"  Open "
\     3 PictureButton                    'P' +k_control pushkey  ;
\        ButtonInfo"  Print Plot "
\     3 PictureButton                    'Q' +k_control pushkey  ;
\        ButtonInfo"  Print BitMap "
\        8 HSpace
\     6 PictureButton                    'X' +k_control pushkey  ; \ cut
\        ButtonInfo"  Cut Window "
\     7 PictureButton                    'C' +k_control pushkey  ; \ copy
\        ButtonInfo"  Copy Window Normal "
\     8 PictureButton                    'V' +k_control pushkey  ; \ paste
\        ButtonInfo"  Paste "
\        8 HSpace
    14 PictureButton                    'R' pushkey            ; \ run
        ButtonInfo" Start the transfer"
    13 PictureButton                    'C' pushkey           ; \ clear
        ButtonInfo" Stop the transfer"
        8 HSpace
     5 PictureButton                    k_F1 pushkey            ; \ help
        ButtonInfo"  Help "
        8 HSpace
ENDBAR

POPUPBAR Demo-Popup-bar

    POPUP " "
        MENUITEM        "Open File..."  'O' +k_control pushkey  ;
        MENUSEPARATOR
        MENUITEM        "Print File..." 'P' +k_control pushkey  ;
        MENUSEPARATOR
        MENUITEM        "Exit"          bye                     ;
ENDBAR

MENUBAR Demo-Menu-bar

\  SYSPOPUP
\     MENUSEPARATOR
\     SUBMENU   "Debugging"
\         MENUITEM  "Print Forth Window"        print-screen ;
\         MENUSEPARATOR
\         MENUITEM  "Exit to Forth"             console abort ;
\         ENDSUBMENU
  
((
    POPUP "&File"
        MENUITEM     "&Open File...  \tCtrl+O"                 'O' +k_control pushkey ;
         SUBMENU      "&Save Bitmap As"
           MENUITEM     "    1 Bits / 2 Colors\t1"              '1' pushkey ;
           MENUITEM     "    4 Bits / 16 Colors\t2"             '2' pushkey ;
           MENUITEM     "    8 Bits / 256 Colors\t3"            '3' pushkey ;
           MENUITEM     "   16 Bits / 65536 Colors\tCtrl+S"     'S' +k_control pushkey ;
           MENUITEM     "   24 Bits / 16 Million Colors\t5"     '5' pushkey ;
           MENUITEM     "   32 Bits / 4 Billion Colors\t6"      '6' pushkey ;
         ENDSUBMENU
        MENUSEPARATOR
        MENUITEM     "Page Setup..."                    'P' +k_control +k_shift pushkey ;
        MENUITEM     "&Print Plot... \tCtrl+P"          'P' +k_control pushkey ;
        MENUITEM     "&Print BMP..."                    'Q' +k_control pushkey ;
        MENUSEPARATOR
        MENUITEM     "E&xit          \tAlt-F4"  bye ;

    POPUP "&Edit"
false   MENUMESSAGE     "Cut"
        SUBMENU         "&Copy"
             MENUITEM   "Plot Window &Normal"   'C' +k_control pushkey ;
             MENUITEM   "Plot Window &Inverted" 'C' +k_control +k_shift pushkey ;
             ENDSUBMENU
        MENUITEM        "Paste"                 'V' +k_control pushkey ;

    POPUP "&Display"
        MENUITEM        "Run Demo     \tEnter"  k_cr  pushkey ;
        MENUITEM        "Run Line Walk"         k_cr  +k_control pushkey ;
        MENUITEM        "Erase Window \t  Esc"  k_esc pushkey ;
        MENUITEM        "Stop Plotting"         k_esc +k_control pushkey ;
))
    POPUP "Remote Page"
        MENUITEM        "Curve set page 'a'"    'A' +k_control  pushkey ;
        MENUITEM        "Curve set page 'b'"    'B' +k_control  pushkey ;
        MENUITEM        "Curve set page 'c'"    'C' +k_control  pushkey ;
        MENUITEM        "Curve set page 'd'"    'D' +k_control  pushkey ;

    POPUP "Reset Unit Time"
        MENUITEM        "Reset Unit Time"       'T' +k_control  pushkey ;

    POPUP "&Help"
        MENUITEM        "Sinar F4 Help"          k_F1 pushkey ;
        MENUSEPARATOR
        MENUITEM        "About Sinar F4"        k_F1 +k_control pushkey ;
ENDBAR

defer D.ComData  \ ' NO-OP to D.ComData

:Object TheMainWindow  <super window

  bit-window  vga-bit-window
  fill-window button-fill-window
  Rectangle   DemoRect
\  Statusbar   StatBar

 2 constant bitorigx
 2 constant bitorigy

MAXSTRING bytes StatusBuf      \ place to collect the status info

:M Classinit:   ( -- )          \ static initialization goes here, IF needed
                ClassInit: super
                ;M

:M On_Init:     ( -- )          \ initialize the class
\ AllocateFileBuffer  	\ allocate the file buffer
        On_Init: super                  \ first init super class
    \    GetHandle: TheMainWindow  call RegisterClass 0= if cr  RED. ." RegisterClassEx error! " RESTORE. .LAST-ERROR #101003 throw  then
        1    SetId: button-fill-window  \ then the child window
        self Start: button-fill-window  \ then startup child window
        2    SetId: vga-bit-window      \ then the child window
        self Start: vga-bit-window      \ then startup child window
        3    SetId: Demo-V-Buttons      \ then the next child window
        self Start: Demo-V-Buttons      \ then startup child window
        4    SetId: Demo-Tool-Bar       \ then the next child window
        self Start: Demo-Tool-Bar       \ then startup child window
        5    SetId: Demo-LR-Buttons     \ then the next child window
        self Start: Demo-LR-Buttons     \ then startup child window
        Demo-menu-bar  SetMenuBar:  self
        Demo-popup-Bar SetPopupBar: vga-bit-window
\        self Start: StatBar             \ the status bar
\   0 0 s" Some text!!!" TEXTOUT: self
;M

:M On_Done:     ( h m w l -- res )
   -1 I'mDone !
   Turnkeyed? if
      comclose
      0 call PostQuitMessage drop
   then
   On_Done: super
0
;M

:M WM_CLOSE     ( h m w l -- res )
                WM_CLOSE WM: Super
\   MyClassName GetHandle: TheMainWindow  call UnRegisterClass 0= if cr  RED. ." UnRegisterClass error! " RESTORE. .LAST-ERROR #1010043 throw  then
                \ bye
                0 ;M

:M Refresh:     ( -- )
\                Paint: StatBar
                Paint: vga-bit-window
                ;M

:M StartSize:   ( -- width height )     \ starting window size
                bitorigx 2* screen-width +
                StartSize: Demo-V-Buttons drop 2 - +  100 max
                bitorigy 2* screen-height +
                StartSize: Demo-Tool-Bar nip + 1+    100 max
\                StartSize: StatBar nip + 1+
                ;M

:M MinSize:     ( -- width height )     \ minimum window size
                bitorigx 2* 100 + StartSize: Demo-V-Buttons drop 2 - +
                                  StartSize: Demo-Tool-Bar drop 1+ max
                bitorigy 2*       StartSize: Demo-V-Buttons nip  4 - +
                                  StartSize: Demo-Tool-Bar nip + 1+
                ;M

:M MaxSize:     ( -- width height )     \ maximum window size
                bitorigx 2* screen-mwidth +
                StartSize: Demo-V-Buttons drop 2 - +
                bitorigy 2* screen-mheight +
                ;M

:M WindowTitle: ( -- Zstring )          \ window caption
                z" Sinar F4 Calibration Curve Download Program"
                ;M

:M WindowStyle: ( -- style )            \ return the window style
                WS_OVERLAPPED WS_CAPTION + WS_SYSMENU + WS_MINIMIZEBOX +
               ;M


:M SetStatus:   ( a1 n1 a2 n2 -- )
   StatusBuf place
   StatusBuf +place
\   StatusBuf count SetText: StatBar \ set the current text on status
\   Paint: StatBar
;M

:M On_Paint:    ( -- )
    s" " ComData() SetStatus: self
                LTGRAY_BRUSH Call GetStockObject
                0 0
                StartSize: self drop width max
                StartSize: Demo-Tool-Bar nip SetRect: DemoRect
                DemoRect.AddrOf rel>abs GetHandle: dc call FillRect ?win-error
                EraseRect: DemoRect
                On_Paint: super
                WHITE                                LineColor: dc \ white color
                0 0                                     MoveTo: dc \ horiz
                StartSize: self drop width max 0        LineTo: dc \ line
                0 0                                     MoveTo: dc \ vertical
                StartSize: Demo-Tool-Bar nip 0 swap     LineTo: dc \ line
                StartSize: Demo-Tool-Bar swap 1+ swap   MoveTo: dc \ vertical
                StartSize: Demo-Tool-Bar drop 1+ 0      LineTo: dc \ line
                BLACK                                LineColor: dc
                0 StartSize: Demo-Tool-Bar nip dup>r    MoveTo: dc
                  StartSize: self drop width max r>     LineTo: dc

                  StartSize: Demo-Tool-Bar over 0       MoveTo: dc
                                                        LineTo: dc

\                s"   "  s" Main status???"  SetStatus: self
\                0 0 0 0 Move: StatBar 	\ move to its default position
\                 On_Paint: StatBar
\                Paint: StatBar
\                StartSize: self  On_Size: self
                ;M

\ the l parameter has already been removed by WINDOW.F, and put
\ into Height and Width

:M On_Size:     ( h m w -- )                  \ handle resize message
                Width  StartSize: Demo-V-Buttons >r - 2 + r>
                Height StartSize: Demo-LR-Buttons bitorigy 2 - 0max +
                swap 4 - >r dup>r - over -
                r> 4 >          \ if there are buttons in the bar
                IF      2 -     \ then leave two more pixels of room
                                \ else we'll already have two pixels of room
                ELSE    r>drop StartSize: Demo-V-Buttons drop 4 - 0max >r
                THEN    r> swap
                        StartSize: Demo-Tool-Bar nip 1+ >r
                        2swap r@ + 2swap r> -
                        Move: button-fill-window

                bitorigx bitorigy StartSize: Demo-Tool-Bar nip + 1+
                Width  StartSize: Demo-V-Buttons drop - 2 -   dup to screen-width
                Height 4 - StartSize: Demo-Tool-Bar nip - 1- 
\                StartSize: StatBar nip 1+ - \ allow room for the status bar  
		dup to screen-height
                Move: vga-bit-window
                  Width  StartSize: Demo-V-Buttons  drop - bitorigy 2 - 0max
                         StartSize: Demo-Tool-Bar   nip + 1+
                         StartSize: Demo-V-Buttons  Move: Demo-V-Buttons
                  Width  StartSize: Demo-LR-Buttons drop -
                  Height StartSize: Demo-LR-Buttons nip  - bitorigy 2 - 0max -
                         StartSize: Demo-LR-Buttons Move: Demo-LR-Buttons
                0 0      StartSize: Demo-Tool-Bar   Move: Demo-Tool-Bar		 
		
\                0 0 0 0 Move: StatBar 	\ move to its default position
                ;M

:M SetVButtonBar: { buttonbar -- }
                buttonbar Demo-V-Buttons <>
                IF      Close: Demo-V-Buttons
                        buttonbar to Demo-V-Buttons
                        self  Start: Demo-V-Buttons
                        On_Size: self
                then
                ;M

:M SetLRButtonBar: { buttonbar -- }
                buttonbar Demo-LR-Buttons <>
                IF      Close: Demo-LR-Buttons
                        buttonbar to Demo-LR-Buttons
                        self  Start: Demo-LR-Buttons
                        On_Size: self
                then
                ;M

((
\ Mouse support connections from the applications window to the bitmapped
\ window that will actually receive the mouse clicks

:M SetClickFunc: ( cfa -- )
                SetClickFunc: vga-bit-window
                ;M

:M SetUnClickFunc: ( cfa -- )
                SetUnClickFunc: vga-bit-window
                ;M

:M SetDblClickFunc: ( cfa -- )
                SetDblClickFunc: vga-bit-window
                ;M

:M SetTrackFunc: ( cfa -- )
                SetTrackFunc: vga-bit-window
                ;M

))
\ All SC_xxxx command types always have the high nibble set to 0xF

:M WM_SYSCOMMAND ( hwnd msg wparam lparam -- res )
                over 0xF000 and 0xF000 <>
                IF      over LOWORD
                        DoMenu: CurrentMenu
                        0
                ELSE    DefWindowProc: [ self ]
                THEN    ;M

;Object

: uninit-demo   ( -- )
                DestroyWindow: TheMainWindow ;

unload-chain chain-add-before uninit-demo

\ ---------------------------------------------------------------
\ Demo about dialog, copied from the Forth About Dialog
\ ---------------------------------------------------------------

create about-demo-msg
         z," Sinar 'F4' Curve Transfer Program V3.4\n"
        +z," Copyright  Sinar Agritec (R&D) Ltd "
        get-local-time time-buf >month,day,year" +z",
        -null, here 0 c, align about-demo-msg - constant about-demo-len

:Object AboutSinarF4  <SUPER dialog

IDD_ABOUT_FORTH forthdlg find-dialog-id constant template

:M On_Init:     ( hWnd-focus -- f )
                about-demo-msg about-demo-len IDD_ABOUT_TEXT  SetDlgItemText: self
                1 ;M

:M Start:       ( -- f )
        Addr: TheMainWindow template run-dialog
;M

:M On_Command:  ( hCtrl code ID -- )
                case
                IDCANCEL of     end-dialog    endof
                                false swap ( default result )
                endcase ;M

;Object


\ 1 PROC RegisterClass ( HINST -- int )
\ 2 PROC UnregisterClass ( classname HINST -- int )

: RegisterWNDCLASS ( -- )   
   \ WNDCLASSEX_2init    \ initialise the Class structure that we are going to register
\   GetHandle: TheMainWindow  
\   call RegisterClass 0= if cr  ." RegisterClassEx error! "  key drop  101003 throw  then
;

: UnregisterWNDCLASS ( -- )   
\   z" ForthAppWindow" GetHandle: TheMainWindow  
\   call UnregisterClass 0= if cr  ." UnregisterClass error! "  key drop  1010043 throw  then
;

: about-demo ( -- )
                start: AboutSinarF4 ;

: "demo-message ( a1 n1 -- )
                message-off
                dup
                IF      StartPos: TheMainWindow StartPos: msg-window
                        rot + >r + r> message-origin
                        MessageText: msg-window
                              Start: msg-window
                ELSE    2drop
                THEN    ;

: demo-message-off ( -- )
                message-off
                StartPos: TheMainWindow StartPos: msg-window
                rot - 0max >r swap - 0max r> message-origin ;

\ copy VGA-DC bitmap, f1=true=inverted

: copy-demo-bitmap   { flag \ hbm hdcMem -- }
                GetHandle: TheMainWindow call OpenClipboard 0=
        IF      s" Can't Open Clipboard\n\n...press a key to continue"
                "demo-message
                key drop demo-message-off
                EXIT
        THEN    flag
                SCREEN-HEIGHT
                SCREEN-WIDTH
                GetHandle: demo-dc
                call CreateCompatibleBitmap to hbm

                GetHandle: demo-dc
                call CreateCompatibleDC to hdcMem

                hbm hdcMem call SelectObject drop
                r>
                IF      NOTSRCCOPY
                ELSE    SRCCOPY
                THEN
                0 0                                     \ y,x origin
                GetHandle: demo-dc                      \ from the screen
                SCREEN-HEIGHT                           \ source height
                SCREEN-WIDTH                            \ source width
                0 0 hdcMem                              \ to new bitmap
                call BitBlt ?win-error                  \ invert the bitmap

                call EmptyClipboard ?win-error  \ clear out the clipboard
                hbm CF_BITMAP call SetClipboardData ?win-error
                call CloseClipboard ?win-error

                hdcMem call DeleteDC ?win-error
\ We don't delete the bitmap because it is now owned by the clipboard !!
\               hbm call DeleteObject ?win-error
                ;

: paste-demo-bitmap   { flag \ hbm hdcMem -- }
                GetHandle: TheMainWindow call OpenClipboard 0=
        IF      s" Can't Open Clipboard\n\n...press a key to continue"
                "demo-message
                2000 ms demo-message-off
                EXIT
        then

                SCREEN-WIDTH
                SCREEN-HEIGHT
                CreateCompatibleBitMap: demo-dc to hbm

                GetHandle: demo-dc

                call CreateCompatibleDC to hdcMem

                CF_BITMAP call GetClipboardData dup to hbm ?win-error

                hbm hdcMem call SelectObject drop

                flag

                IF     NOTSRCCOPY
                ELSE   SRCCOPY
                THEN
                0 0                       \ y,x origin
                hdcMem                    \ from memory dc
                SCREEN-HEIGHT             \ source height
                SCREEN-WIDTH              \ source width
                0 0                       \ y,x dest
                GetHandle: demo-dc        \ to screen

                call BitBlt ?win-error          \ invert the bitmap

                call CloseClipboard ?win-error

                hdcMem call DeleteDC ?win-error
\               hbm call DeleteObject ?win-error
                ;


FileOpenDialog ViewBitmap "Open Bitmap File" "Bitmap Files (*.BMP)|*.BMP|*.DIB|All Files (*.*)|*.*|"
FileSaveDialog SaveBitmap "Save Bitmap File" "Bitmap Files (*.BMP)|*.BMP|*.DIB|All Files (*.*)|*.*|"

\ ---------------------------------------------------------------
\ Open image file support
\ ---------------------------------------------------------------

: open-demo-bitmap     { \ open$ hbm hdcMem --  }
                max-path LocalAlloc: open$
                GetHandle: TheMainWindow Start: ViewBitmap dup c@ \ -- a1 n1
                IF      count open$ place
                        LR_LOADFROMFILE
                        LR_CREATEDIBSECTION or
                        NULL
                        NULL
                        IMAGE_BITMAP
                        open$ dup +NULL 1+ rel>abs
                        NULL
                        Call LoadImage to hbm
                        GetHandle: demo-dc
                        Call CreateCompatibleDC to hdcMem
                        hbm hdcMem Call SelectObject  drop

                        SRCCOPY                                   \
                        0 0                                       \ y,x origin
                        hdcMem                                    \ from memory dc
                        SCREEN-HEIGHT                             \ height of dest rect
                        SCREEN-WIDTH                              \ width of dest rect
                        0 0                                       \ y,x dest
                        GetHandle: demo-dc                        \ to screen

                        Call BitBlt ?win-error                    \

                        hdcMem Call DeleteDC ?win-error

                ELSE    DROP
                THEN
;

\ ---------------------------------------------------------------
\ Save File support
\ ---------------------------------------------------------------

        4 constant sizeof(RGBQUAD)
       14 constant sizeof(BitmapFileHeader)
       40 constant sizeof(BitmapInfoHeader)

        0 constant biSize
        4 constant biWidth
        8 constant biHeight
       12 constant biPlanes
       14 constant biBitCount
       16 constant biCompression
       20 constant biSizeImage
       24 constant biXPelsPerMeter
       28 constant biYPelsPerMeter
       32 constant biClrUsed
       36 constant biClrImportant

: show-BITMAPINFOHEADER { pbmih \ bmih$ -- }
        max-path localalloc: bmih$
        s" BITMAPINFOHEADER"                   bmih$  place
        s" \nbiSize : "                        bmih$ +place
       pbmih biSize + @           0 <# #s #>   bmih$ +place
        s" \nbiWidth : "                       bmih$ +place
       pbmih biWidth + @          0 <# #s #>   bmih$ +place
        s" \nbiHeight : "                      bmih$ +place
       pbmih biHeight + @         0 <# #s #>   bmih$ +place
        s" \nbiPlanes : "                      bmih$ +place
       pbmih biPlanes + w@        0 <# #s #>   bmih$ +place
        s" \nbiBitCount : "                    bmih$ +place
       pbmih biBitcount + w@      0 <# #s #>   bmih$ +place
        s" \nbiCompression : "                 bmih$ +place
       pbmih biCompression + @    0 <# #s #>   bmih$ +place
        s" \nbiSizeImage : "                   bmih$ +place
       pbmih biSizeImage + @      0 <# #s #>   bmih$ +place
        s" \nbiXPelsPerMeter : "               bmih$ +place
       pbmih biXPelsPerMeter + @  0 <# #s #>   bmih$ +place
        s" \nbiYPelsPerMeter : "               bmih$ +place
       pbmih biYPelsPerMeter + @  0 <# #s #>   bmih$ +place
        s" \nbiClrUsed : "                     bmih$ +place
       pbmih biClrUsed + @        0 <# #s #>   bmih$ +place
        s" \nbiClrImportant :"                 bmih$ +place
       pbmih biClrImportant + @   0 <# #s #>   bmih$ +place
       bmih$ count "message key drop message-off
        ;


: save-demo-bitmap { nBits \  pbmi lpBits hbm  hdcMem hfile nrgbquad BitmapFileHeader save$  -- }
        14 LocalAlloc: BitmapFileHeader
        max-path    LocalAlloc: save$
        s" Save Bitmap File: "  save$ place
        nBits (.)               save$ +place
        s"  Bit"                save$ +place
        save$ count SetTitle: SaveBitmap
        GetHandle: TheMainWindow Start: SaveBitmap dup c@

     IF count save$ place

        sizeof(BitmapInfoHeader)  sizeof(RGBQUAD) 256 * + malloc to pbmi
        pbmi sizeof(BitmapInfoHeader) sizeof(RGBQUAD) 256 * + erase   \ (1) DON'T DELETE THIS LINE
                                                                      \

        sizeof(BitmapInfoHeader)                   pbmi biSize            +   !
        SCREEN-WIDTH                               pbmi biWidth           +   !
        SCREEN-HEIGHT                              pbmi biHeight          +   !
        1                                          pbmi biPlanes          +  w!
        nBits                                      pbmi biBitCount        +  w!

        nBits
         CASE
          1 OF BI_RGB    2 to nrgbquad    ENDOF
          4 OF BI_RLE4  16 to nrgbquad    ENDOF \ Could also be BI_RGB for
          8 OF BI_RLE8 256 to nrgbquad    ENDOF \ uncompressed format
         16 OF BI_RGB    0 to nrgbquad    ENDOF
         24 OF BI_RGB    0 to nrgbquad    ENDOF
         32 OF BI_RGB    0 to nrgbquad    ENDOF
         ENDCASE                                   pbmi biCompression     +   !

      \  0    pbmi biSizeImage       +   !       NOT NEEDED           (1)
      \  0    pbmi biXPelsPerMeter   +   !       SINCE
      \  0    pbmi biYPelsPerMeter   +   !       pbmi IS ERASED
      \  0    pbmi biClrUsed         +   !       ABOVE
      \  0    pbmi biClrImportant    +   !


        SCREEN-HEIGHT
        SCREEN-WIDTH
        GetHandle: demo-dc
        Call CreateCompatibleBitmap to hbm


        GetHandle: demo-dc
        Call CreateCompatibleDC to hdcMem
        hbm hdcMem Call SelectObject drop

        SRCCOPY                                   \
        0 0                                       \ y,x origin
        GetHandle: demo-dc                        \ from screen dc
        SCREEN-HEIGHT                             \ height of dest rect
        SCREEN-WIDTH                              \ width of dest rect
        0 0                                       \ y,x dest
        hdcMem                                    \ to memory dc
        Call BitBlt ?win-error                    \


        DIB_RGB_COLORS
        pbmi rel>abs
        NULL
        SCREEN-HEIGHT
        0
        hbm
        hdcMem
        Call GetDIBits 0= abort" 1st GetDIBits"


\        pbmi show-bitmapinfoheader

        pbmi biSizeImage + @ malloc rel>abs to lpBits
        lpBits abs>rel pbmi biSizeImage + @ erase


        DIB_RGB_COLORS
        pbmi rel>abs
        lpBits
        SCREEN-HEIGHT
        0
        hbm
        hdcMem
        Call GetDIBits 0= abort" 2nd GetDIBits"

\        pbmi show-bitmapinfoheader

        save$
        count
        GENERIC_READ GENERIC_WRITE or
        create-file abort" CreateFile"
        to hfile

        0x4d42 BitmapFileHeader     w!                        \ hdr.bfType

        sizeof(BitmapFileHeader)
        sizeof(BitmapInfoHeader) +
        nrgbquad sizeof(RGBQUAD) * +
        pbmi biSizeImage + @     +
               BitmapFileHeader 2 +  !                        \ hdr.bfSize

        0      BitmapFileHeader 6 + w!                        \ hdr.bfReserved1
        0      BitmapFileHeader 8 + w!                        \ hdr.bfReserved2

        sizeof(BitmapFileHeader)
        sizeof(BitmapInfoHeader) +
        nrgbquad sizeof(RGBQUAD) * +
               BitmapFileHeader 10 + !                        \ hdr.bfOffBits

        BitmapFileHeader
        sizeof(BitmapFileHeader)
        hfile write-file  drop


        pbmi
        sizeof(BitmapInfoHeader)
        nrgbquad sizeof(RGBQUAD) * +
        hfile write-file drop

        lpBits abs>rel
        pbmi biSizeImage + @
        hfile write-file drop

        hfile close-file drop

        hdcMem call DeleteDC ?win-error
        hbm call DeleteObject ?win-error


        lpBits abs>rel release
        pbmi release
     ELSE drop
     THEN
        ;
defer save-bitmap

' save-demo-bitmap is save-bitmap

only forth also definitions

