\ *****************************************************************************
\ ** Q Variables
\  Just like normal variables and buffers, but have more than one
\  instance, selected by the value in Qselect
\ *****************************************************************************

4 constant NUM_QSELECTS

variable Qselect     \ selects one set of variables and buffers. 
\ Note : must not be a USER variable!!! Windows "tasks" have ther own user space...

\ Four COM ports are defined : COM-A COM-B COM-C and COM-D , each port has its own "real" COM port setting and baudrate etc
\ All settings are saved in the registry and restored by GetRegValues
\ Type .COMS to see the current settings.
\ This allows a program to access more than one COM port
: COM-A ( -- )   0 Qselect ! ;
: COM-B ( -- )   1 Qselect ! ;
: COM-C ( -- )   2 Qselect ! ;
: COM-D ( -- )   3 Qselect ! ;

COM-A

(( 
: serialColour   
   Qselect @ case
   0 of  NORMAL.  endof
   1 of  BLUE.    endof
   2 of  MAGENTA. endof
   3 of  CYAN.    endof
   INVERSE.
   endcase
;

: .serialPort
   serialColour
   Qselect @ case
   0 of  ." COM port A "  endof
   1 of  ." COM port B "  endof
   0 of  ." COM port C "  endof
   1 of  ." COM port D "  endof
      RED. ." Unknown COM port =" dup 3 .hex
   endcase
   serialColour
;
))

: Qvariable     \ "<spaces>name" -- ; Exec: -- a-addr
  create
    NUM_QSELECTS cells allot
  does>
    Qselect @ NUM_QSELECTS 1- and cells +
;

: 2Qvariable     \ "name" -- ; [child] -- a-addr
\ *G Defines a 2variable, with a version for each Qselect value
   create
      NUM_QSELECTS 2* cells allot
   does>
      Qselect @  NUM_QSELECTS 1- and  2*  cells +
;

: Qbuffer:       \ n "name" -- ; [child] -- addr                 
( *G Create a multiple memory buffer called "name" which is 'n' bytes long.      )
( ** When "name" is executed the address of the buffer is returned.     )
    Create
    dup ,                  \ save the buffer size
    NUM_QSELECTS *         \ allot one for each comport
    Here Over Allot Swap Erase
  Does>
    dup @                  \ get the size
    Qselect @ NUM_QSELECTS 1- and * +  \ offset to the correct buffer
    cell +                 \ step over the size field
;

((
\ test Qvariables

Qvariable TestQvar

: TTQvar
   0 Qselect !  100 TestQvar !
   1 Qselect !  101 TestQvar !
   2 Qselect !  102 TestQvar !

   1 Qselect !  TestQvar @ cr ." 1 = " .
   0 Qselect !  TestQvar @  ."   0 = " .
   2 Qselect !  TestQvar @  ."   2 = " .
;

\ test Qbuffer:s
2 cells Qbuffer: TestQbuf

: TTqbuf
   0 Qselect !  100 0 TestQbuf 2!
   1 Qselect !  101 0 TestQbuf 2!
   2 Qselect !  102 0 TestQbuf 2!

   1 Qselect !  TestQbuf 2@ cr ." 1 = " d.
   0 Qselect !  TestQbuf 2@  ."   0 = " d.
   2 Qselect !  TestQbuf 2@  ."   2 = " d.
;
))
