\ SinarRemF5.f 2018 Feb 22
\ From MNET F5 functions

decimal

: .ACCESS ; \ inform the user

: ResetServiceTimer  ( MSG1< ) 
   #SPECIES+1 lastLine !   \ hide the timeout text
   CheckCOMport
   s" Reset 1 year service timer?"  s" Press OK to reset service timer" Dialogue
   1 = if
      page
      0 3 c>p s" Resetting 1 year service timer...                                 " Htype 
      16 RFUNC
      Success @ if 
         0 3 c>p   s" Service timer has been reset.                                " Htype 
         s" Information" s" Service timer has been reset." Monologue
      else
         0 3 c>p   s" Failed! Service timer has NOT been reset!!!                  " Htype 
         s" Error!" s" Service timer has NOT been reset." Monologue
      then
   then
\   1000 ms
\   0 3 c>p   s"                                 " Htype 
\   IF  ."  Done."  THEN  ( >MSG ) 
;

decimal

: ShowLanguageInfo ( -- )
\   0 5 c>p   s" Language configuration : " Htype 
   5 4 c>p  LanguageConfigBuffer[] @ 0 base @ >r  hex  <# # # #>  r> base ! Htype
   5 5 c>p LanguageName0[] count  Htype
   5 6 c>p LanguageName1[] count  Htype
   5 7 c>p LanguageName2[] count  Htype
   5 8 c>p LanguageName3[] count  Htype
;

: SetLanguageConfig  ( -- ) 
   #SPECIES+1 lastLine !   \ hide the timeout text
   CheckCOMport
   s" SetLanguageConfig?"  s" Press OK set the Language configuration" Dialogue
   1 = not if  exit  then
 
\   start: PasswordDialog
((
   PasswordOK? not if  
      s" Wrong password!!!" s" " Monologue
      exit  
   then
))
   4 0 do 
      GetLangaugeInfo 0= if  
         s" Check connection!"  s" Could not read from unit" Monologue
      else
         leave
      then
   loop

   Start: LanguageDialog

   vLanguageOptionsSet @ if
   \   s" Information" s" Language options have been set." Monologue
   then
;


\ CODE @time ( - d m y h m s)    -DISK USE                        
\    2A #B 0 HI MOV   21 INT   0 0 SUB   2 0 MOV B  0 PUSH        
\    2 HI 0 MOV B 0 PUSH  1 0 MOV  7D0 # 0 SUB  0 PUSH            
\    2C #B 0 HI MOV   21 INT                                      
\    0 0 SUB   1 HI 0 MOV B   0 PUSH   1 0 MOV B   0 PUSH         
\    2 HI 0 MOV B  0 PUSH   NEXT  DECIMAL                         

decimal

: GetTime&Date ( - d m y h m s)    
   19 02 10 11 21 00
;

VARIABLE RTCPAD 4 ALLOT                                         

: @RTCPAD   time&date  2000 -  
   6 0 DO  RTCPAD I + C!  LOOP 
   \ swap round year and day... not sure why...
   RTCPAD c@ 
   RTCPAD 2 + c@ 
   RTCPAD c!
   RTCPAD 2 + c!
;           

decimal

: ResetUnitTime  ( MSG1< ) 
   CheckCOMport
   s" Set remote unit's time?"  s" Press OK to set remote unit's time" Dialogue
   1 = if
\      OPEN-ACCESS 
\      \page
 \     0 3 c>p  s" Setting remote unit's time...                                    " Htype 
 \     0 4 c>p  s"                                                                  " Htype 
      @RTCPAD  RTCPAD 1003 RemoteCurveOut
      if 
\         0 3 c>p   s" Remote unit's time has been set                              " Htype 
         s" Information" s" Remote unit's time has been set" Monologue
      else
\         0 3 c>p   s" Failed! Remote unit's time has NOT been set!!!               " Htype 
         s" Error!" s" Remote unit's time has NOT been set." Monologue
      then
   then
\   CLOSE-ACCESS
\   1000 ms
\   0 3 c>p   s"                                 " Htype 
\   IF  ."  Done."  THEN  ( >MSG ) 
;

decimal
\s

: FNT   \MES  ." Set remote unit's time?"  Y/N-EXIT
   24 55 TAB  OPEN-ACCESS  \MES ." Time is " DATE TIME          
   @RTCPAD  RTCPAD 1003 RemoteCurveOut                              
   IF  ."   Remote time set."  ELSE  ."   Failed!"  THEN        
   CLOSE-ACCESS  \MES ;                                         


decimal

\s

( F5 - Remote Test & Calibration)
(( 
( Title page layout)  2 +B LOAD                                 
( F1 entry of values)  3 +B 4 +B THRU                           
( Clear calibration)  5 +B LOAD                                 
( Display channel data)  6 +B LOAD                              
( Remote functions)  7 +B 9 +B THRU                             
( Taring)  10 +B LOAD                                           
( Scaling and un-taring)  11 +B LOAD                            
( ... ) 12 +B 13 +B THRU                                        
( Arrows)  14 +B LOAD                                           
( Set remote time)  15 +B LOAD                                  
( Function table)  16 +B LOAD                                   
( Test program)  17 +B 18 +B THRU                               
))                                                                
                                                                
: .RTC   0 60 TAB  DATE  TIME ;                                 

: TITLE   PAGE  \ .BAUD  .RTC                                     
   0 20 TAB  ." F5 - Remote Test & Calibration"                 
   1 20 TAB  ." =============================="                 
    4 0 TAB  ." A : User Identification :"                      
    9 0 TAB  ." B : Code 0 reading : "                          
   10 0 TAB ."     Uncorrected + Correction = Code 0   degC. Sam
ple Ambient Grams"                                              
   14 0 TAB  ." C : Hardware Tests :"                           
 15 0 TAB ."     Cell Low   Cell High   Temperature       Mass" 
   18 0 TAB  ." D : Checksum of all curves in Remote Unit :"    
   20 0 TAB  ." E : Display Remote Message     F : Continuous   
  G : Activate Remote Unit"                                     
   21 0 TAB  ." R : Recalibration Menu         V : Version/Seria
l Z : Set Serial Number"  22 0 TAB  ." T : Set remote unit's tim
e     S : Set Service Time" ; 

( user ID entry)                                                
: .RUSER  6 0 TAB  RUSER >V 80 TYPE  \MES ;                     
: FNA   \MES  ." Enter User Identification :"  PAD 80 BLANK     
   6 0 TAB  PAD 80 BLANK  PAD 80 MARK  6 0 TAB                  
   PAD 80 EXPECT  SPAN C@  80 OVER - PAD ROT + SWAP BLANK       
   6 0 TAB  PAD 80 TYPE  \MES  ." Save this text"  Y/N-EXIT     
   PAD RUSER >V 80 MOVE  UPDATE  .RUSER ;                       
: DTB   DTA >R   I 10 + @  7 + 16 / DUP  2/ .P1  6 SPACES       
   I 12 + @  2/ SWAP  2/ -  .P1  6 SPACES  R> 12 + @  2/ .P1    
6 SPACES DTA 2+ @ .P1 DTA 4 + @ .P1 DTA 6 + @ 100 256 */ .P1 ;  
: DTC   DTA >R   I 2@  SWAP  12 U.R  12 U.R  2 SPACES           
   I 4 + @ 12 U.R  R> 6 + @  12 U.R ;                           
: DTD   DTA 14 + @  HEX 10 U.R  DECIMAL ;                       
: FNB   .ACCESS  11 0 TAB                                       
   1 RFUNC  IF  DTB  \MES  ELSE  \MES  ." Failed!"  THEN ;      
                                                                
( Remote functions)                                             
: FNC   .ACCESS  16 0 TAB  2 RFUNC  IF  DTC  \MES  ELSE         
      \MES  ." Failed!"  THEN ;                                 
                                                                
: FND   .ACCESS  18 44 TAB                                      
   4 RFUNC  IF  DTD  \MES  ELSE  \MES  ." Failed!"  THEN ;      
                                                                
: FNF   .ACCESS   ." Hold down any key to stop..."              
   TELEPHONE  \MES ;                                            
                                                                
HERE  "   H44AP FPAFP A92FC4GP DP FRM---"  2+                   
: .UTYPE ( n)    3 * LITERAL + 3 TYPE ;                         
: .UNIT-TYPE   ."   Unit type "  DTA @ 1000 /MOD .UTYPE         
   ."  Version" .P1  ."   Serial Number "  DTA 8 + 8 TYPE ;     
: FNV   .ACCESS  5 RFUNC IF  \MES  .UNIT-TYPE                   
      ELSE  \MES  ." Failed!"  THEN ;                           
( Remote functions)                                             
: SPACE>ZERO ( a n)   OVER + SWAP DO                            
   I C@ 32 = IF  0 I C!  THEN  LOOP ;                           
CREATE "DONGLE"  32 STRING DONGLE                               
: CONFIRM-DONGLE   DONGLE-CONFIRMED @ 0= IF                     
      \MES  ." Enter Dongle Password : "                        
      PAD 24 ERASE  PAD 8 EXPECT  PAD 8 SPACE>ZERO              
      PAD 8 DONGLE-PW 8 -MATCH  SWAP DROP                       
      PAD 6 "DONGLE" COUNT -MATCH  SWAP DROP  AND               
      IF   \MES  ." Wrong!!!"  3000 MS  2R> 2DROP EXIT  THEN    
      -1 DONGLE-CONFIRMED !  THEN ;                             
                                                                
: ENTER-SERIAL#   \MES  ." Enter New Serial No. : "             
   PAD 8 + 16 ERASE  PAD 24 + 8 EXPECT SPAN C@ ?DUP IF          
      PAD 24 + PAD 8 + ROT MOVE  ELSE                           
      DONGLE-PW 8 + PAD 8 + 8 MOVE  THEN ;                      
( Remote functions)                                             
: FNZ   \MES  ." Set Remote's Serial No.?"  Y/N-EXIT            
   CONFIRM-DONGLE  ENTER-SERIAL#                                
   ( Magic number)  12345678. PAD 16 + 2!                       
   ( OPEN-ACCESS )  .ACCESS   9 RCTRL                           
   .ACCESS  PAD 10000 RemoteCurveOut                                
   ( CLOSE-ACCESS )  8 RCTRL  FNV ;                             
                                                                
: FNCF   \MES  ." Remote chipForth?"  Y/N-EXIT                  
   .ACCESS  14 RCTRL                                            
   \MES  ." Remote unit is in chipForth mode...ctrlI to clear :"
   ;                                                            
HEX                                                             
: FNNCF   \MES  ." Clear Remote chipForth?"  Y/N-EXIT           
   ( Execute vector at hex 3E ) RCHIPFORTH                      
   \MES  ." Remote unit is in normal mode." ;                   

   ( Remote functions)                                          
: (FNG)   -1 'FAIL !  0 TME !  REMOTE ACTIVATE \REM  \P         
   30 0 DO [ASCII] Y EMIT  55 MS LOOP  \P  0 EMIT               
   6 0 DO  55 MS  [ASCII] X  EMIT  LOOP                         
   KEY NAK = IF  0 'FAIL !  THEN  STOP ;  
   
: FNG  \MES  ." Activating Remote Unit..."  (FNG)  200 set_Timeout  
   IF  \MES  ." Remote Unit Responding"  ELSE  ." Failed!!!"    
      THEN ; 
      
: DTCD   5 0 TAB  ." Calibration Data Area in decimal :"        
   7 0 TAB  16 PAD + PAD DO  I @ 10 U.R  2 +LOOP                
   9 0 TAB  48 PAD + PAD 16 + DO  I @ 10 U.R  2 +LOOP           
   13 0 TAB  ." Calibration Data Area in hexadecimal :"         
  15 0 TAB  HEX  48 PAD + PAD DO  I @ 10 U.R  2 +LOOP DECIMAL ;
  
: 0FNCD   PAGE  .ACCESS  2 26 TAB  ." Calibration Data Area 0"  
   0 PAD RDATA-IN  IF  DTCD  \MES  ELSE  \MES  ." Failed!"  THEN
   KEY DROP  TITLE ; 
   
   ( Remote functions)                                          
: 1FNCD   PAGE  .ACCESS  2 26 TAB  ." Calibration Data Area 1"  
   6 1 TAB  ."  '0CAPT MF cnt, scl  '1CAPT MF cnt, scl"         
   6 41 TAB  ."  '0CAPT HF cnt, scl  '1CAPT HF cnt, scl"        
   8 4 TAB  ." '0MASS     '1MASS cnt, scl "                     
   1 PAD RDATA-IN  IF  DTCD  \MES  ELSE  \MES  ." Failed!"  THEN
   KEY DROP  TITLE ;                                            
                                                                
: 2FNCD  PAGE  .ACCESS  2 26 TAB  ." Calibration Data Area 2"   
   2 PAD RDATA-IN  IF  DTCD  \MES  ELSE  \MES  ." Failed!"  THEN
   KEY DROP  TITLE ;                                            
                                                                
: RFUNC+   RFUNC  .RESULT ;                                     
                                                                
   ( Remote functions)  HEX                                     
: 0CAL   .ACCESS  4000 RFUNC+ ; : 1CAL   .ACCESS  E000 RFUNC+ ; 
: X0CAL   \MES  ." Empty Calibration" Y/N-EXIT 0CAL ;           
: 1MASS  \MES ." Mass cal." Y/N-EXIT  .ACCESS  2000 RFUNC+ ;    
: SET-TEMP  \MES ." Temp. cal." Y/N-EXIT .ACCESS  6000 RFUNC+ ; 
: X1CAL   \MES  ." Full Calibration" Y/N-EXIT 1CAL ;            
: !'?TEMP    .ACCESS  C000 '?TEMP V@ 1FFF AND OR RFUNC+ ;       
: XTEMP   \MES  ." Enter Temperature :"  '?TEMP V@ enter. IF    
      '?TEMP V!  !'?TEMP  6 39 TAB  '?TEMP V@ .P1  THEN  \MES ; 
: XUNLOAD   \MES ." Message : Please Unload the cell" 4 RMSG ;  
: XFILL   \MES   ." Message : Please Fill the cell"  5 RMSG ;   
: !'?CODE0   .ACCESS 8000 '?CODE0 V@ 1FFF AND OR RFUNC+ ;       
: XCODE0   \MES  ." Enter Code 0 :"  '?CODE0 V@ enter. IF       
   '?CODE0 V!  !'?CODE0  7 39 TAB  '?CODE0 V@ .P1  THEN  \MES ; 
: .KSTAT  5 RFUNC DUP IF  10 32 TAB  DTA 2+ @ DUP -1 = IF  DROP 
      ." No key. "  ELSE DUP EMIT 7 U.R  THEN  THEN  .RESULT ;  
( Recal menu)                                                   
HERE  " Blank     -HI-      Chat      Bye     Unload    Fill    
Open      Hello  "  3 +                                         
: >msg ( n - a n)   7 AND  9 *  24 OVER 7 + TAB  LITERAL + 9 ;  
: .MSGS   8 0 DO  I >msg TYPE  LOOP  MSG# V@  >msg  MARK ;      
: CLEAR-UP   23 0 TAB 80 SPACES  24 0 TAB 79 SPACES ;           
: FNE   23 7 TAB ." Use arrow keys or numbers to select message,
 then press enter :"                                            
   BEGIN  .MSGS  KEY >R                                         
   I 0= IF  0  'KEY 1+ C@ 77 = IF  1+  THEN                     
               'KEY 1+ C@ 75 = IF  1-  THEN  MSG# V@ + MSG# V!  
      THEN                                                      
      I 48 58 WITHIN IF  I 1- 0 MAX  MSG# V!  THEN              
      I 27 = IF  CLEAR-UP  R> DROP  EXIT  THEN                  
      I [ASCII] M = R> 13 = OR UNTIL                            
   CLEAR-UP  MSG# V@  .ACCESS  RMSG  ;                          
( Recal menu)                                                   
: .FNR   PAGE 2 26 TAB  ." Recalibration Menu"                  
              3 26 TAB  ." =================="                  
    5 12 TAB  ." 1) Press E for Empty Calibration."             
   6 12 TAB  ." 2) Press T to enter calibration Temperature : " 
   7 12 TAB  ." 3) Press C to enter calibration       Code0 : " 
8 15 TAB ." Note : Press T and C before doing Full calibration."
    9 12 TAB  ." 4) Press F for Full Calibration."              
   15 12 TAB  ." Press A for Unload Message, B for Fill."       
   16 12 TAB  ." Press K for Remote Keypad status"              
   17 12 TAB  ." Press G for 180g Mass cal."                    
   18 12 TAB  ." Press S for Set temperature cal."              
   19 12 TAB  ." Press M to send message to Remote Unit."       
   20 12 TAB  ." Press Esc to return to main menu." ;           
                                                                
                                                                
( Recal menu)                                                   
: {FNR} ( n - f)   >R                                           
   I [ASCII] E = IF  X0CAL  THEN  I [ASCII] F = IF  X1CAL  THEN 
   I [ASCII] 1 = IF  X0CAL  THEN  I [ASCII] 4 = IF  X1CAL  THEN 
   I [ASCII] C = IF  XCODE0  THEN  I [ASCII] T = IF  XTEMP  THEN
   I [ASCII] 3 = IF  XCODE0  THEN  I [ASCII] 2 = IF  XTEMP  THEN
   I [ASCII] A = IF  XUNLOAD  THEN  I [ASCII] B = IF  XFILL THEN
   I [ASCII] K = IF  \MES  12 50 TAB  8 SPACES  .KSTAT  THEN    
   I [ASCII] H = IF  18 +HELP  .FNR  0 ?H? !  KEY DROP  THEN    
   I [ASCII] G = IF  1MASS  THEN  I [ASCII] S = IF SET-TEMP THEN
   I [ASCII] M = IF  FNE  THEN                                  
   I [ASCII] Q = I 27 = R> 0= OR OR ;                           
                                                                
: FNR   PASS?  .FNR  BEGIN  .RTC  +KEY  U-CASE  {FNR}  UNTIL    
   TITLE .RUSER ;                                               
                                                                
( Arrows)                                                       
VARIABLE 'ENTERED                                               
                                                                
: -BYTE   BYTE V@ 31 + 32 MOD  BYTE V!  0 'ENTERED ! ;          
: +BYTE   BYTE V@ 1+ 32 MOD  BYTE V!  0 'ENTERED ! ;            
                                                                
: ARROWS ( n)   >R                                              
   I CAN-DO? I 71 = OR IF  R> 'FK !  R> DROP  EXIT  THEN        
   I 117 = IF ( ctrlEnd)  R> DROP  >FORTH  THEN                 
   I 73 = IF  ( pgUp)   THEN                                    
   I 81 = IF  ( pgDn)   THEN                                    
   I 75 = IF ( left)    THEN                                    
   I 77 = IF ( right)   THEN                                    
   I 72 = IF  ( up)     THEN                                    
   R> 80 = IF ( down)   THEN ;                                  
                                                                
( Remote Time Set )                                             
: FNS   \MES  ." Reset 1 year service timer?"  Y/N-EXIT         
   .ACCESS  16 RFUNC IF  \MES ."  Done."  THEN ;   

HEX  
   
CODE @time ( - d m y h m s)    -DISK USE                        
   2A #B 0 HI MOV   21 INT   0 0 SUB   2 0 MOV B  0 PUSH        
   2 HI 0 MOV B 0 PUSH  1 0 MOV  7D0 # 0 SUB  0 PUSH            
   2C #B 0 HI MOV   21 INT                                      
   0 0 SUB   1 HI 0 MOV B   0 PUSH   1 0 MOV B   0 PUSH         
   2 HI 0 MOV B  0 PUSH   NEXT  DECIMAL                         
VARIABLE RTCPAD 4 ALLOT                                         
: @RTCPAD   @time  6 0 DO  RTCPAD 5 I - + C!  LOOP ;            
: FNT   \MES  ." Set remote unit's time?"  Y/N-EXIT             
   24 55 TAB  OPEN-ACCESS  \MES ." Time is " DATE TIME          
   @RTCPAD  RTCPAD 1003 RemoteCurveOut                              
   IF  ."   Remote time set."  ELSE  ."   Failed!"  THEN        
   CLOSE-ACCESS  \MES ;                                         
( Function table)                                               
VARIABLE VECTORS 254 ALLOT  VECTORS 256 ERASE  VECTORS !VECTORS 
02 :V ( ctrlB) COMPORT-TOGGLE ;                                 
08 :V ( ctrlH ) FNCF ;  09 :V ( ctrlI) FNNCF ;                  
04 :V   0FNCD ;   05 :V   1FNCD ;  06 :V   2FNCD ;              
22 :V ( ctrlV)  6 GAIN-ACCESS  ." Unit unlocked" ;              
23 :V ( ctrlW)  7 GAIN-ACCESS  ." Unit locked" ;                
24 :V ( ctrlX)  CLOSE-ACCESS+ ." Unit Closed" ;                 
25 :V ( ctrlY)  OPEN-ACCESS+  ." Unit Opened" ;                 
26 :V ( ctrlZ)   \MES  ." Clear Unit"  Y/N-EXIT  ?PI            
   12 GAIN-ACCESS  ." Remote Unit cleared" ;                    
27 :V   ?BYE ;   :K S  FNS ;                                    
:K A   FNA .RUSER ;  :K B   FNB ;   :K C   FNC ;   :K D   FND ; 
:K E   FNE ;         :K F   FNF ;   :K G   FNG ;                
:K H   13 +HELP  TITLE ;  :K M   FNE ;   :K Q   ?BYE ;          
:K R   FNR ;  :K T  FNT ;  :K V  FNV ;  :K Z   FNZ ;            
( F5 Test program)                                              
: run   0 DONGLE-CONFIRMED !                                    
   ?LOG-EXIT  >H  VECTORS !VECTORS  TITLE  .RUSER               
   BEGIN  .RTC  +KEY U-CASE DUP IF  FUNCTION  ELSE  DROP        
   ( arrows)  'KEY 1+ C@ ARROWS  THEN   AGAIN ;                 
                                                                
                                                                
                                                                
 
